#Frank et al. 2022 ACE2 Analyses

## analyzing the ACE2 data - Finding unique types of contact residues
require(plyr)
ACE2 <-read.csv("~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_residues_2022-05-11.csv")
ACE2full <-ACE2[,-1]
nrow(ACE2full)
str(ACE2full)
ACE2full$X28 <-as.character(rep("F",nrow(ACE2full)))

for(i in 8:31){
  ACE2full<-ACE2full[ACE2full[,i]!="",] # getting rid of ones iwth blank data
}
Unique_types <-count(ACE2full[1:271,], vars=names(ACE2full)[8:31])
Unique_types[Unique_types$freq>5,]
#write.csv(Unique_types)
paste(Unique_types[1,1],Unique_types[1,2])
Unique_types$Seq <-rep("",nrow(Unique_types)) # going to make a concatenated sequence type
head(Unique_types)

for (i in 1:24){
  for (j in 1:nrow(Unique_types)){
    Unique_types[j,26]<-paste(Unique_types[j,26],Unique_types[j,i],sep="")
  }
  
}
# that worked
head(Unique_types)

# Doing the same thing for my ACE2full 
ACE2full$seq <-rep("",nrow(ACE2full))
for (i in 8:31){
  for (j in 1:nrow(ACE2full)){
    ACE2full[j,32]<-paste(ACE2full[j,32],ACE2full[j,i],sep="")
  }
  
}

Unique_types$type <-seq(1:nrow(Unique_types))
head(Unique_types)
head(ACE2full)
ACE2full$type <-rep("",nrow(ACE2full))

for(i in 1:nrow(ACE2full)){
  Seq <-ACE2full[i,32]
  Type <-Unique_types[Unique_types$Seq==as.character(Seq),27]
  ACE2full[i,33]<-Type
  
}

#write.csv(ACE2full, file="~/Documents/Temp_DPP4/Full_seqs_with_type_2022-05-11.csv")
## Getting binding residue information on the 7 most commonly cited ACE2 residues that contact SARS-CoV and SARS-CoV-2 

Subset_types <-count(ACE2full, vars=c("X27","X31","X35","X38","X41","X82","X353"))


Subset_types$Seq <-rep("",nrow(Subset_types)) # going to make a concatenated sequence type
head(Subset_types)

for (i in 1:7){
  for (j in 1:nrow(Subset_types)){
    Subset_types[j,9]<-paste(Subset_types[j,9],Subset_types[j,i],sep="")
  }
  
}
names(ACE2full)

ACE2full$subsetseq <-rep("",nrow(ACE2full))
for (i in c(9,12,14,16,17,21,27)){
  for (j in 1:nrow(ACE2full)){
    ACE2full[j,34]<-paste(ACE2full[j,34],ACE2full[j,i],sep="")
  }
  
}
head(ACE2full)
Subset_types$type <-seq(1:nrow(Subset_types))
head(Subset_types)
ACE2full$subsettype <-rep("",nrow(ACE2full))

for(i in 1:nrow(ACE2full)){
  Seq <-ACE2full[i,34]
  Type <-Subset_types[Subset_types$Seq==as.character(Seq),10]
  ACE2full[i,35]<-Type
  
}

head(ACE2full)
#write.csv(ACE2full, file="~/Documents/Temp_DPP4/Full_seqs_with_type_2022-05-11.csv")


## Calculating residue diversity ###
Residues <-read.csv("~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_residues_2022-05-16.csv")
Residues <-Residues[,-1]
head(Residues); names(Residues)
Residues[Residues$X28=="FALSE"&!is.na(Residues$X28),10] <-"F"
Residues[is.na(Residues$X28),10] <-""
head(Residues); names(Residues) #8-31
str(Residues)

Chiroptera <-Residues[Residues$Order=="Chiroptera",]
NotBat <-Residues[Residues$Order!="Chiroptera",]

library(vegan)

Thing <-xtabs(~X24,data=Residues)
AminoCount <-matrix(nrow=24, ncol=20)
colnames(AminoCount)<-c("A","C","D","E","F","G","H","I","K","L","M","N","P","Q","R","S","T","V","W","Y")
rownames(AminoCount)<-colnames(Residues[8:31])
for(i in 8:31){
  AminoCount[i-7,1]<-nrow(Residues[Residues[,i]=="A",])
  AminoCount[i-7,2]<-nrow(Residues[Residues[,i]=="C",])
  AminoCount[i-7,3]<-nrow(Residues[Residues[,i]=="D",])
  AminoCount[i-7,4]<-nrow(Residues[Residues[,i]=="E",])
  AminoCount[i-7,5]<-nrow(Residues[Residues[,i]=="F",])
  AminoCount[i-7,6]<-nrow(Residues[Residues[,i]=="G",])
  AminoCount[i-7,7]<-nrow(Residues[Residues[,i]=="H",])
  AminoCount[i-7,8]<-nrow(Residues[Residues[,i]=="I",])
  AminoCount[i-7,9]<-nrow(Residues[Residues[,i]=="K",])
  AminoCount[i-7,10]<-nrow(Residues[Residues[,i]=="L",])
  AminoCount[i-7,11]<-nrow(Residues[Residues[,i]=="M",])
  AminoCount[i-7,12]<-nrow(Residues[Residues[,i]=="N",])
  AminoCount[i-7,13]<-nrow(Residues[Residues[,i]=="P",])
  AminoCount[i-7,14]<-nrow(Residues[Residues[,i]=="Q",])
  AminoCount[i-7,15]<-nrow(Residues[Residues[,i]=="R",])
  AminoCount[i-7,16]<-nrow(Residues[Residues[,i]=="S",])
  AminoCount[i-7,17]<-nrow(Residues[Residues[,i]=="T",])
  AminoCount[i-7,18]<-nrow(Residues[Residues[,i]=="V",])
  AminoCount[i-7,19]<-nrow(Residues[Residues[,i]=="W",])
  AminoCount[i-7,20]<-nrow(Residues[Residues[,i]=="Y",])
}


Residues$X28


Shannons <-diversity(AminoCount, index="shannon")
Species <-specnumber(AminoCount)
Evenness <-Shannons/log(Species)

# Bat count
Thing <-xtabs(~X24,data=Residues)
AminoCountBat <-matrix(nrow=24, ncol=20)
colnames(AminoCountBat)<-c("A","C","D","E","F","G","H","I","K","L","M","N","P","Q","R","S","T","V","W","Y")
rownames(AminoCountBat)<-colnames(Chiroptera[8:31])
for(i in 8:31){
  AminoCountBat[i-7,1]<-nrow(Chiroptera[Chiroptera[,i]=="A",])
  AminoCountBat[i-7,2]<-nrow(Chiroptera[Chiroptera[,i]=="C",])
  AminoCountBat[i-7,3]<-nrow(Chiroptera[Chiroptera[,i]=="D",])
  AminoCountBat[i-7,4]<-nrow(Chiroptera[Chiroptera[,i]=="E",])
  AminoCountBat[i-7,5]<-nrow(Chiroptera[Chiroptera[,i]=="F",])
  AminoCountBat[i-7,6]<-nrow(Chiroptera[Chiroptera[,i]=="G",])
  AminoCountBat[i-7,7]<-nrow(Chiroptera[Chiroptera[,i]=="H",])
  AminoCountBat[i-7,8]<-nrow(Chiroptera[Chiroptera[,i]=="I",])
  AminoCountBat[i-7,9]<-nrow(Chiroptera[Chiroptera[,i]=="K",])
  AminoCountBat[i-7,10]<-nrow(Chiroptera[Chiroptera[,i]=="L",])
  AminoCountBat[i-7,11]<-nrow(Chiroptera[Chiroptera[,i]=="M",])
  AminoCountBat[i-7,12]<-nrow(Chiroptera[Chiroptera[,i]=="N",])
  AminoCountBat[i-7,13]<-nrow(Chiroptera[Chiroptera[,i]=="P",])
  AminoCountBat[i-7,14]<-nrow(Chiroptera[Chiroptera[,i]=="Q",])
  AminoCountBat[i-7,15]<-nrow(Chiroptera[Chiroptera[,i]=="R",])
  AminoCountBat[i-7,16]<-nrow(Chiroptera[Chiroptera[,i]=="S",])
  AminoCountBat[i-7,17]<-nrow(Chiroptera[Chiroptera[,i]=="T",])
  AminoCountBat[i-7,18]<-nrow(Chiroptera[Chiroptera[,i]=="V",])
  AminoCountBat[i-7,19]<-nrow(Chiroptera[Chiroptera[,i]=="W",])
  AminoCountBat[i-7,20]<-nrow(Chiroptera[Chiroptera[,i]=="Y",])
}

head(AminoCountBat)
#AminoCountBat[3,c(1:4,6:20)]<-0
#AminoCountBat[3,5]<-91 # don't know why position 28 is indexing weird
ShannonsBat <-diversity(AminoCountBat, index="shannon")
SpeciesBat <-specnumber(AminoCountBat)
EvennessBat<-ShannonsBat/log(SpeciesBat)

rbind(ShannonsBat,SpeciesBat,EvennessBat)

# Notbat count
Thing <-xtabs(~X24,data=Residues)
AminoCountNotBat <-matrix(nrow=24, ncol=20)
colnames(AminoCountNotBat)<-c("A","C","D","E","F","G","H","I","K","L","M","N","P","Q","R","S","T","V","W","Y")
rownames(AminoCountNotBat)<-colnames(NotBat[8:31])
for(i in 8:31){
  AminoCountNotBat[i-7,1]<-nrow(NotBat[NotBat[,i]=="A",])
  AminoCountNotBat[i-7,2]<-nrow(NotBat[NotBat[,i]=="C",])
  AminoCountNotBat[i-7,3]<-nrow(NotBat[NotBat[,i]=="D",])
  AminoCountNotBat[i-7,4]<-nrow(NotBat[NotBat[,i]=="E",])
  AminoCountNotBat[i-7,5]<-nrow(NotBat[NotBat[,i]=="F",])
  AminoCountNotBat[i-7,6]<-nrow(NotBat[NotBat[,i]=="G",])
  AminoCountNotBat[i-7,7]<-nrow(NotBat[NotBat[,i]=="H",])
  AminoCountNotBat[i-7,8]<-nrow(NotBat[NotBat[,i]=="I",])
  AminoCountNotBat[i-7,9]<-nrow(NotBat[NotBat[,i]=="K",])
  AminoCountNotBat[i-7,10]<-nrow(NotBat[NotBat[,i]=="L",])
  AminoCountNotBat[i-7,11]<-nrow(NotBat[NotBat[,i]=="M",])
  AminoCountNotBat[i-7,12]<-nrow(NotBat[NotBat[,i]=="N",])
  AminoCountNotBat[i-7,13]<-nrow(NotBat[NotBat[,i]=="P",])
  AminoCountNotBat[i-7,14]<-nrow(NotBat[NotBat[,i]=="Q",])
  AminoCountNotBat[i-7,15]<-nrow(NotBat[NotBat[,i]=="R",])
  AminoCountNotBat[i-7,16]<-nrow(NotBat[NotBat[,i]=="S",])
  AminoCountNotBat[i-7,17]<-nrow(NotBat[NotBat[,i]=="T",])
  AminoCountNotBat[i-7,18]<-nrow(NotBat[NotBat[,i]=="V",])
  AminoCountNotBat[i-7,19]<-nrow(NotBat[NotBat[,i]=="W",])
  AminoCountNotBat[i-7,20]<-nrow(NotBat[NotBat[,i]=="Y",])
}

head(AminoCountNotBat)
#AminoCountNotBat[3,c(1:4,6:20)]<-0
#AminoCountNotBat[3,5]<-109 # don't know why position 28 is indexing weird
ShannonsNotBat <-diversity(AminoCountNotBat, index="shannon")
SpeciesNotBat <-specnumber(AminoCountNotBat)
EvennessNotBat<-ShannonsNotBat/log(SpeciesNotBat)

cbind(Shannons, Species, Evenness, ShannonsBat,SpeciesBat,EvennessBat,ShannonsNotBat,SpeciesNotBat,EvennessNotBat)



colSums(AminoCount) # C is rarely used
rowSums(AminoCount)

## Calculating residue similarity to humans ###


Residues$humanorsimilar <-rep(0,nrow(Residues))
Residues$bad <-rep(0,nrow(Residues))
Residues$count <-rep(0,nrow(Residues))
Residues$sarshuman<-rep(0,nrow(Residues))
Residues$sarsbad<-rep(0,nrow(Residues))
Residues$sarscount<-rep(0,nrow(Residues))
Residues$sarsiihuman<-rep(0,nrow(Residues))
Residues$sarsiibad<-rep(0,nrow(Residues))
Residues$sarsiicount<-rep(0,nrow(Residues))

names(Residues)


for (i in 1:nrow(Residues)){
  if(Residues[i,8]%in%c("Q","N")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,8]%in%c("A","L","M","P")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,8]%in%c("Q","N")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,8]%in%c("A","L","M","P")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,8]%in%c("Q","N")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,8]%in%c("A","L","M","P")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,9]%in%c("T","A","I")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,9]%in%c("D","E","K","Q")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,9]%in%c("T","A","I")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,9]%in%c("D","E","K","Q")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,9]%in%c("T","A","I")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,9]%in%c("D","E","K","Q")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,10]%in%c("F")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,10]%in%c("F")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,10]%in%c("F")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,11]%in%c("D","E")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,11]%in%c("K")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,11]%in%c("D","E")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,11]%in%c("K")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,12]%in%c("K","R")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,12]%in%c("A","D","E","G")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,12]%in%c("K","R")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,12]%in%c("A","D","E","G")){Residues[i,41]<-(Residues[i,41]+1)}  
  if(Residues[i,12]%in%c("K","R")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,12]%in%c("A","D","E","G")){Residues[i,44]<-(Residues[i,44]+1)}  
  
  if(Residues[i,13]%in%c("H","K","R")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,13]%in%c("A","F","E")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,13]%in%c("H","K","R")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,13]%in%c("A","F","E")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,13]%in%c("H","K","R")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,13]%in%c("A","F","E")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,14]%in%c("E","D")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,14]%in%c("A","K")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,14]%in%c("E","D")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,14]%in%c("A","K")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,14]%in%c("E","D")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,14]%in%c("A","K")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,15]%in%c("E")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,15]%in%c("E")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,15]%in%c("E")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,16]%in%c("D","E")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,16]%in%c("V","K")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,16]%in%c("D","E")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,16]%in%c("V","K")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,16]%in%c("D","E")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,16]%in%c("V","K")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,17]%in%c("Y","H")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,17]%in%c("Y","H")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,17]%in%c("Y","H")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,18]%in%c("Q","N")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,18]%in%c("L")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,18]%in%c("Q","N")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,18]%in%c("L")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,18]%in%c("Q","N")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,18]%in%c("L")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,19]%in%c("L","I","V")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,19]%in%c("L","I","V")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,19]%in%c("L","I","V")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,20]%in%c("L","I","V")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,20]%in%c("T","N","Q","D","R","H")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,20]%in%c("L","I","V")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,20]%in%c("T","N","Q","D","R","H")){Residues[i,41]<-(Residues[i,41]+1)} 
  
  if(Residues[i,21]%in%c("M","I","V")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,21]%in%c("T", "S","D","R","H")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,21]%in%c("M","I","V")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,21]%in%c("T", "S","D","R","H")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,21]%in%c("M","I","V")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,21]%in%c("T", "S","D","R","H")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,22]%in%c("Y")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,22]%in%c("Y")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,22]%in%c("Y")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,23]%in%c("N")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,23]%in%c("N")){Residues[i,40]<-(Residues[i,40]+1)}
  
  if(Residues[i,24]%in%c("Q")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,24]%in%c("A","P")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,24]%in%c("Q")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,24]%in%c("A","P")){Residues[i,41]<-(Residues[i,41]+1)}
  
  if(Residues[i,25]%in%c("D","E")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,25]%in%c("R","K")){Residues[i,38]<-(Residues[i,38]+1)}
  if(Residues[i,25]%in%c("D","E")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,25]%in%c("R","K")){Residues[i,41]<-(Residues[i,41]+1)}
  if(Residues[i,25]%in%c("D","E")){Residues[i,43]<-(Residues[i,43]+1)}
  if(Residues[i,25]%in%c("R","K")){Residues[i,44]<-(Residues[i,44]+1)}
  
  if(Residues[i,26]%in%c("N")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,26]%in%c("N")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,26]%in%c("N")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,27]%in%c("K")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,27]%in%c("K")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,27]%in%c("K")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,28]%in%c("G")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,28]%in%c("G")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,28]%in%c("G")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,29]%in%c("D","E")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,29]%in%c("D","E")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,29]%in%c("D","E")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,30]%in%c("R")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,30]%in%c("R")){Residues[i,40]<-(Residues[i,40]+1)}
  if(Residues[i,30]%in%c("R")){Residues[i,43]<-(Residues[i,43]+1)}
  
  if(Residues[i,31]%in%c("R","K")){Residues[i,37]<-(Residues[i,37]+1)}
  if(Residues[i,31]%in%c("R","K")){Residues[i,43]<-(Residues[i,43]+1)}
  
  Count <-Residues[i,8:31]!=""
  Residues[i,39]<-length(Count[Count==T])
  Sarscount <-Residues[i,c(8:10,12:30)]!=""
  Residues[i,42]<-length(Sarscount[Sarscount==T])
  Sarsiicount <-Residues[i,c(8:19,21:22,25:31)]!=""
  Residues[i,45]<-length(Sarsiicount[Sarsiicount==T])
  }

Residues$count; Residues$sarsiicount; Residues$sarscount
names(Residues)
Residues$humanscore <-(Residues$humanorsimilar-Residues$bad)/Residues$count
Residues$humanscore

#calculating the scores
Residues$sarsscore <-(Residues$sarshuman-Residues$sarsbad)/Residues$sarscount
Residues$sarsiiscore <-(Residues$sarsiihuman-Residues$sarsiibad)/Residues$sarsiicount

write.csv(Residues, file="~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_residues_all_with_scores_2022-05-16.csv")














































## Pruning the tree for the aBSREL analyses ------

require(phytools)
require(geiger)
require(ape)
require(jsonlite)

UphamMCC <-read.nexus(file="~/Documents/Temp_DPP4/Upham_MCC_no_fossil.tre.txt")
str(UphamMCC)
is.ultrametric(UphamMCC)
#plot(UphamMCC)

Tips<-read.csv("~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_upham_names_2022-05-16.csv")
head(Tips)
tail(Tips)

rownames(Tips)<-Tips$Upham_name
Tester <-extract.clade(UphamMCC,5400)
plot(Tester)

drop <-name.check(UphamMCC, Tips)
drop$data_not_tree


PrunedUphamMCC <-drop.tip(UphamMCC, drop$tree_not_data)
plot(PrunedUphamMCC)

# rename
PrunedUphamMCC$tip.label
Pruned2 <-PrunedUphamMCC 
head(Tips)


for(j in 1:nrow(Tips)){
  Temp<-Pruned2$tip.label[j]
  Pruned2$tip.label[Pruned2$tip.label==Temp]<-as.character(Tips[Tips$Upham_name==Temp,2])
}


Pruned2$tip.label
layout(c(1))
par(mar=c(1,1,1,1))
plot(Pruned2)

write.nexus(Pruned2, file="~/Documents/Temp_DPP4/Upham_MCC_renamed_204spp_forACE2_2022-05-16.nexus")
write.tree(Pruned2, file="~/Documents/Temp_DPP4/Upham_MCC_renamed_204spp_forACE2_2022-05-16.newick")
Pruned2<-read.nexus(file="~/Desktop/ACE2/Analyses/Trees_and_alignments/Upham_MCC_renamed_203spp_2021-02-11.nexus")



# now getting a bat versus not bat tree
Bats <-Tips[Tips$Order=="Chiroptera",]
rownames(Bats)<-Bats$Species
head(Bats[,1:3])

Batdrop <-name.check(Pruned2, Bats)
BatACE2tree <-drop.tip(Pruned2,Batdrop$tree_not_data)
plot(BatACE2tree)

write.tree(BatACE2tree, file="~/Documents/Temp_DPP4/Upham_MCC_ACE2_batsonly_2022-05-16.newick")

length(BatACE2tree$tip.label)


















































#Checking for variable sites and completeness ### --------

AllRes <-read.csv(file="~/Documents/Temp_DPP4/ACE2_residue_alignment_2022-05-23c.csv")
head(AllRes)
names(AllRes)
length(unique(AllRes$X1)[!is.na(unique(AllRes$X1))]) # gets the number of unique not NA characters
length(unique(AllRes$X82)[!is.na(unique(AllRes$X82))])
length(unique(AllRes$X1))

Test <-unique(AllRes$X715)
Test <-Test[Test!=""]
Test <-Test[!is.na(Test)]


length(Test)

Changing <-matrix(,nrow=ncol(AllRes), ncol=2)
for (i in 1:ncol(AllRes)){
  Changing[i,1] <-colnames(AllRes)[i]
  Test <-unique(AllRes[,i])
  Test <-Test[Test!=""]
  Test <-Test[!is.na(Test)]
  Changing[i,2] <-length(Test)
}
head(Changing)
tail(Changing)
colnames(Changing) <- c("Variable", "Unique_residues")
ChangingDF <-data.frame(Changing)
nrow(ChangingDF[ChangingDF$Unique_residues==1,])
Changing[1:100,]

write.csv(Changing, file="~/Documents/Temp_DPP4/Manuscript_finalization/Variant_sites_2022-05-23.csv")


tAllRes <-t(AllRes)
tAllResDF <-data.frame(tAllRes)
Sample <-tAllResDF[,8]
Sample2 <-Sample; length(Sample)
Sample2 <-Sample2[!is.na(Sample2)]; length(Sample2)
Sample2 <-Sample2[Sample2!=""]; length(Sample2)
Sample2 <-Sample2[4:length(Sample2)] #805
head(tAllResDF)

Sampling <-matrix(,nrow=ncol(tAllRes),ncol=3)
for (i in 1:ncol(tAllRes)){
  Sample <-tAllResDF[,i]
  Sample2 <-Sample; length(Sample)
  Sample2 <-Sample2[!is.na(Sample2)]; length(Sample2)
  Sample2 <-Sample2[Sample2!=""]; length(Sample2)
  Sample3 <-Sample2[3:length(Sample2)] 
  Sampling[i,1]<-as.character(Sample2[1])
  Sampling[i,2]<-as.character(Sample2[2])
  Sampling[i,3]<-length(Sample3)
}

head(Sampling)
write.csv(Sampling, file="~/Documents/Temp_DPP4/Manuscript_finalization/Sample_coverage_2022-05-23.csv")
Sampling <-read.csv(file="~/Documents/Temp_DPP4/Manuscript_finalization/Sample_coverage_2022-05-23.csv")
head(Sampling)
wilcox.test(V3~V2, data=Sampling, paired=F) # p < 7 e -16 ; W = 6387.5
boxplot(V3~V2, data=Sampling)


shapiro.test(Sampling[,3])
mean(Sampling[Sampling$V2==0,4]) # Mean publicly available
mean(Sampling[Sampling$V2==1,4]) # Mean that I generated

sd(Sampling[Sampling$V2==0,4])/sqrt(length(Sampling[Sampling$V2==0,4]))
sd(Sampling[Sampling$V2==1,4])/sqrt(length(Sampling[Sampling$V2==1,4]))


## Extracting the aBSREL results from the json

require(jsonlite)

JSONS <-list.files(path="~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_May_2022/", pattern = ".json", full.names=F,recursive=F)
for (j in 3:3){
  Thing <- read_json(paste("~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_May_2022/",JSONS[j], sep=""), simplifyVector = T)
  #Thing[[5]] # <- fifth thing is the number of branches tested and hte number of positive results
  Results <-Thing[[2]]
  OfInterest<-Results[[1]]
  ResultTable <-data.frame(matrix(,ncol=4, nrow=length(OfInterest)))
  for(i in 1:length(OfInterest)){
    Temp <-OfInterest[[i]]
    ResultTable[i,1]<-names(OfInterest)[i]
    ResultTable[i,2]<-Temp$LRT
    ResultTable[i,3]<-Temp$`Uncorrected P-value`
    ResultTable[i,4]<-Temp$`Corrected P-value`
  }
  colnames(ResultTable)<-c("Name", "LRT", "Uncorrected p-value", "Corrected p-value")
  ResultTable2 <-ResultTable[1:nrow(ResultTable),]
  write.csv(ResultTable2, file= paste("~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_May_2022/",strsplit(JSONS[j],".json")[[1]][1],"_ABSRELsummary.csv",sep=""))
}

head(ResultTable2)

## Extracting the MEME results from the JSON

JSONS <-list.files(path="~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_May_2022/", pattern = "*.json", full.names=F,recursive=F)
for (i in c(1,4)){
  MEME1 <- read_json(paste("~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_May_2022/",JSONS[i], sep=""), simplifyVector = T)
  #str(MEME1)
  #head(MEME1$MLE)
  CodonTable <-data.frame(MEME1$MLE$content)
  colnames(CodonTable)<-MEME1$MLE$headers[,1]
  #head(MEME1$MLE$headers)
  
  write.csv(CodonTable, file=paste("~/Documents/Temp_DPP4/Manuscript_finalization/ACE2_May_2022/",strsplit(JSONS[i],".json")[[1]][1],"_MEMEsummary.csv",sep=""))
  
}

## Fisher's exact tests -------

## Fisher's exact tests for number of branches under selection
fisher.test(matrix(c(76,114,54,161),nrow=2, byrow=T))  # p = 0.001926 (Bats vs. non bats no bonferroni)
fisher.test(matrix(c(20,170,9,206),nrow=2, byrow=T))  # p = 0.01924 (Bats vs. non bats bonferroni)

# terminal branches only
fisher.test(matrix(c(44,52,30,78),nrow=2, byrow=T))  # p = 0.008748 (Bats vs. non bats no bonferroni)
fisher.test(matrix(c(10,86,6,102),nrow=2, byrow=T))  # p = 0.2967 (Bats vs. non bats bonferroni)

#terminal branches with only reference sequences
fisher.test(matrix(c(25,25,30,78),nrow=2, byrow=T))  # p = 0.007549 (Bats vs. non bats no bonferroni)
fisher.test(matrix(c(5,45,6,102),nrow=2, byrow=T))  # p = 0.326 (Bats vs. non bats bonferroni)

#Rhinolophids
fisher.test(matrix(c(7,12,69,102),nrow=2, byrow=T))  # p = 0.81 (Rhinolophids vs. other bats no bonferroni)
fisher.test(matrix(c(2,17,18,153),nrow=2, byrow=T))  # p = 1 (Rhinolophids vs. other bats bonferroni)

## Some fisher's exact tests for differences in the number of branches under selection in ACE2
#MCC not bat

fisher.test(matrix(c(3,17,64,516),nrow=2, byrow=T)) # p = 0.4802 (only variant sites with human analogs; SARS; p < 0.05 sites)
fisher.test(matrix(c(3,16,64,517),nrow=2, byrow=T)) # p = 0.460 (only variant sites with human analogs; SARS2; p < 0.05 sites)
fisher.test(matrix(c(2,12,65,521),nrow=2, byrow=T)) # p = 0.6632 (only variant sites with human analogs; NL63; p < 0.05 sites)

# p < 0.1
fisher.test(matrix(c(4,16,88,492),nrow=2, byrow=T)) # p = 0.529 (only variant sites with human analogs; SARS; p < 0.1 sites)
fisher.test(matrix(c(4,15,88,493),nrow=2, byrow=T)) # p = 0.5135 (only variant sites with human analogs; SARS2; p < 0.1 sites)
fisher.test(matrix(c(3,11,89,497),nrow=2, byrow=T)) # p = 0.461 (only variant sites with human analogs; NL63; p < 0.1 sites)


## MCC full bats 
fisher.test(matrix(c(6,14,78,502),nrow=2, byrow=T)) # p = 0.02401 (only variant sites with human analogs; SARS; p < 0.05 sites)
fisher.test(matrix(c(7,12,77,504),nrow=2, byrow=T)) # p = 0.01008 (only variant sites with human analogs; SARS2; p < 0.05 sites)
fisher.test(matrix(c(5,9,79,507),nrow=2, byrow=T)) # p = 0.0754 (only variant sites with human analogs; NL63; p < 0.05 sites)

# p < 0.1
fisher.test(matrix(c(7,13,111,469),nrow=2, byrow=T)) # p = 0.0886 (only variant sites with human analogs; SARS; p < 0.1 sites)
fisher.test(matrix(c(9,10,109,472),nrow=2, byrow=T)) # p = 0.005176 (only variant sites with human analogs; SARS2; p < 0.1 sites)
fisher.test(matrix(c(5,9,113,473),nrow=2, byrow=T)) # p = 0.165 (only variant sites with human analogs; NL63; p < 0.1 sites)

require(ggplot2)
require(gridExtra)



## Making the figures ### ------

Score_data <-read.csv(file="~/Documents/Temp_DPP4/Manuscript_finalization/Scores_for_plotting_2022-05-26.csv")
head(Score_data)
plot(SARS_score~SARS2_score, data=Score_data)
plot(dpp4score~SARS2_score, data=Score_data)
Score_data_original <-Score_data
str(Score_data_original)
#Score_data2 <-Score_data[is.na(Score_data$Duplicate),]
Score_data2 <-Score_data
head(Score_data2)
SARSscores <-Score_data2[Score_data2$ace2count>21,c(1,3,4)]
SARS2scores <-Score_data2[Score_data2$ace2count>21,c(1,3,5)]
MERS <-Score_data2[Score_data2$dpp4count>12,c(1,3,7)]

SARSscores$Virus <-rep("SARS-CoV"); names(SARSscores)<-c("Species", "Order", "Score","Virus")
head(SARSscores)
SARS2scores$Virus <-rep("SARS-CoV-2"); names(SARS2scores)<-c("Species", "Order", "Score","Virus")
MERS$Virus <-rep("MERS"); names(MERS)<-c("Species", "Order", "Score","Virus")
Scores <-rbind(SARSscores,SARS2scores, MERS)
Scores <-Scores[!is.na(Scores$Score),]

Scores[(Scores$Order%in%c("Pholidota","Lagomorpha","Perissodactyla","Macroscelidea","Sirenia","Cingulata","Eulipotyphla","Dermoptera","Pilosa","Scadentia",
                          "Proboscidea","Diprodontia", "Tubulidentata","Afrosoricida","Monotremata","Didelphimorphia")),2]<-"Other"
Scores[Scores$Order=="Carnivora (Pinnipedia)",2]<-"Carnivora"
Scores[Scores$Order=="Artiodactyla (Cetacea)",2]<-"Artiodactyla"

# this is for plotting Figure S1
Score2 <-Score_data2
Score2[(Score2$Order%in%c("Pholidota","Lagomorpha","Perissodactyla","Macroscelidea","Sirenia","Cingulata","Eulipotyphla","Dermoptera","Pilosa","Scadentia",
                          "Proboscidea","Diprodontia", "Tubulidentata","Afrosoricida","Monotremata","Didelphimorphia")),3]<-"Other"
Score2[Score2$Order=="Carnivora (Pinnipedia)",3]<-"Carnivora"
Score2[Score2$Order=="Artiodactyla (Cetacea)",3]<-"Artiodactyla"

## Making figure 2

require(ggplot2)
require(gridExtra)

head(Scores)


#getting the susceptibility scores

Thing <-read.csv(file="~/Documents/Temp_DPP4/Manuscript_finalization/susceptibility_2022-05-26.csv")
Thing2 <-Thing
Thing<-Thing[Thing$Infection!="",]
Thing<-Thing[!is.na(Thing$SARS_2_score),]

Thing[(Thing$Order%in%c("Pholidota","Lagomorpha","Perissodactyla","Macroscelidea","Sirenia","Cingulata","Eulipotyphla","Dermoptera","Pilosa","Scadentia",
                          "Proboscidea","Diprodontia", "Tubulidentata","Afrosoricida","Monotremata","Didelphimorphia")),7]<-"Other"
Thing[Thing$Order=="Carnivora (Pinnipedia)",7]<-"Carnivora"
Thing[Thing$Order=="Artiodactyla (Cetacea)",7]<-"Artiodactyla"

#This creates figure 2:
plot1<-ggplot(Scores, aes(x=Order, y=Score, fill=Virus, shape=Virus))+ geom_boxplot(outlier.color=NA) +theme_bw()+labs(y="Similarity to human in residues that contact virus")+scale_fill_manual(values=c("white","gray85","gray55"))+geom_point(position=position_jitterdodge(jitter.width = 0.2, jitter.height = 0.005),size=2, alpha=0.5)+scale_shape_manual(values=c(18,15,16))
graph2 <-ggplot(Thing, aes(x=Infection, y=SARS_2_score))+ geom_boxplot(outlier.color=NA) +theme_bw()+labs(y="Similarity to human in residues that contact SARS-CoV-2")+geom_jitter(aes(shape=Order),width=0.2,height=0.01,size=3, alpha=0.5)
grid.arrange(plot1, graph2, widths=c(2,1),nrow=1)


#This plots figure S1
ggplot(Score2,aes(x=SARS2_score, y=dpp4score, color=Order, shape=Order))+theme_bw()+geom_jitter(width=0.01, height=0.01,size=3, alpha=0.75)+labs(x="Similarity to human in residues that bind SARS-CoV-2", y="Similarity to human in residues that bind MERS-CoV")

## Figure S2
head(Score_data2)
BatSARSscores <-Score_data2[Score_data2$ace2count>21,c(1,10,4)]
BatSARS2scores <-Score_data2[Score_data2$ace2count>21,c(1,10,5)]
BatMERS <-Score_data2[Score_data2$dpp4count>12,c(1,10,7)]

BatSARSscores$Virus <-rep("SARS-CoV"); names(BatSARSscores)<-c("Species", "Group", "Score","Virus")
head(BatSARSscores)
BatSARS2scores$Virus <-rep("SARS-CoV-2"); names(BatSARS2scores)<-c("Species", "Group", "Score","Virus")
BatMERS$Virus <-rep("MERS"); names(BatMERS)<-c("Species", "Group", "Score","Virus")
BatScores <-rbind(BatSARSscores,BatSARS2scores)
BatScores <-BatScores[!is.na(BatScores$Score),]
BatScores <-BatScores[BatScores$Group!="",]
BatScores[BatScores$Group=="Other",2]<-"Other bats"
BatScores[BatScores$Group=="Rhino",2]<-"Rhinolophus spp."
BatScores[BatScores$Group=="Rsinicus",2]<-"R. sinicus"

ggplot(BatScores, aes(x=Group, y=Score, fill=Virus, shape=Virus))+ geom_boxplot(outlier.color=NA) +theme_bw()+labs(y="Similarity to human in residues that contact virus")+scale_fill_manual(values=c("white","gray85","gray55"))+geom_point(position=position_jitterdodge(jitter.width = 0.2, jitter.height = 0.005),size=2, alpha=0.5)+scale_shape_manual(values=c(18,15,16))


t.test(SARS_2_score~Infection, data=Thing, paired=F)

## Comparing SARS2 and SARS1 scores
head(Score_data)
wilcox.test(Score_data[Score_data$Order=="Chiroptera"&Score_data$ace2count>21&is.na(Score_data$Duplicate),4], Score_data[Score_data$Order=="Chiroptera"&Score_data$ace2count>21&is.na(Score_data$Duplicate),5], paired=T, alternative="two.sided")
wilcox.test(Score_data[Score_data$Order%in%c("Carnivora", "Carnivora (Pinnipedia)")&Score_data$ace2count>21&is.na(Score_data$Duplicate),4], Score_data[Score_data$Order%in%c("Carnivora", "Carnivora (Pinnipedia)")&Score_data$ace2count>21&is.na(Score_data$Duplicate),5], paired=T, alternative="two.sided")

?wilcox.test
